#include <iostream>
#include <cassert>
#include <climits>

using namespace std;

unsigned long long b;
const unsigned long long INFINITY = ULLONG_MAX-1;
int maxdepth = -1;

bool possible (unsigned long long n) {
	for (int i = b-1; i >= 2; i--)
		while ((n % i) == 0) {
			n /= i;
			maxdepth++;
		}
	return (n == 1);
}

unsigned long long sol (unsigned long long n, int maxdigit, int depth) {
	if (n < b) {
		maxdepth = depth;
		return n;	
	}
	if (depth > maxdepth)
		return INFINITY/b - b;
	unsigned long long ret = INFINITY;
	for (int i = maxdigit; i >= 2; i--)
		if ((n % i) == 0)
			ret = min(ret, b*sol(n/i, i, depth+1) + i);	
	if (ret < 0)
		cerr << "Negative sol(" << n << ", " << maxdigit << ", " << depth << ") = " <<ret << "\n";		
	if (ret < INFINITY/2)
		return ret;
	else
		return INFINITY/b - b;
}

int main () {
	unsigned long long n;
	cin >> b >> n;
	if (!possible(n)) {
		cout << "impossible\n";
		return 0;
	}
	cout << sol(n,b-1,0) << "\n";
	return 0;
}



